LeetCode[219] Contains Duplicate II

本文介绍了一种使用哈希表的方法来解决寻找数组中是否存在两个不同的下标i和j,使得nums[i]=nums[j]且i与j之间的差的绝对值不超过k的问题。通过遍历数组并利用哈希表记录每个元素的最新位置,可以高效地检查是否存在满足条件的重复元素。

摘要生成于 C知道 ,由 DeepSeek-R1 满血版支持, 前往体验 >

Given an array of integers and an integer k, find out whether there are two distinct indices i and j in the array such that nums[i] = nums[j]and the difference between i and j is at most k.


建立哈希表,值为下标,顺序遍历nuns元素,若发现相等元素,计算 i - hash[nums[i]],若满足则返回true。若大于k,更新hash[nums[i]],因为 i 的值只会越来越大,先前的下标值已经没有意义了。

class Solution {
public:
	bool containsNearbyDuplicate(vector<int>& nums, int k) {
		unordered_map<int, int> hash;
		for (int i = 0; i < nums.size(); i++)
		{
			if (hash.find(nums[i]) != hash.end() && i - hash[nums[i]] <= k)
				return true;
			hash[nums[i]] = i;
		}
		return false;
	}
};

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值